
0000            00000  ;Rock & Scroll
0000            00000  ;by Andrew Hunt
0000            00000  ;from Your Sinclair, Feb'92
0000            00000  ;with corrections by
0000            00000  ;Jim Grimwood, August 2005
0000            00000  ;(see comments below)
0000            00000         org  65000
FDE8 00         00000  MSG    defb 00
FDE9 0000       00000  OFFSET defb 00,00
FDEB 00000000   00000  CHAR   defb 0,0,0,0,0,0,0,0
FDEF 00000000
FDF3 0000       00000  LEN    defb 00,00
FDF5 07         00000  COLOUR defb 07
FDF6 003C7E7E   00000  UDG    defb 00,03ch,07eh,07eh
FDFA 7E7E3C00   00000         defb 07eh,07eh,03ch,00
FDFE CD9EFE     00000  START1 call RESET
FE01 ED4BF3FD   00000  START2 ld   bc,(LEN)
FE05 C5         00000  NXTCHR push bc
FE06 ED5BE9FD   00000         ld   de,(OFFSET)
FE0A D5         00000         push de
FE0B CD1EFE     00000         call COPY
FE0E CD7EFE     00000         call SHOW
FE11 D1         00000         pop  de
FE12 13         00000         inc  de
FE13 ED53E9FD   00000         ld   (OFFSET),de
FE17 C1         00000         pop  bc
FE18 0B         00000         dec  bc
FE19 78         00000         ld   a,b
FE1A B1         00000         or   c
FE1B 20E8       00000         jr   nz,NXTCHR
FE1D C9         00000         ret
FE1E            00000  ;
FE1E 21E8FD     00000  COPY   ld   hl,MSG
FE21 ED52       00000         sbc  hl,de
FE23 6E         00000         ld   l,(hl)
FE24 7D         00000         ld   a,l
FE25 D620       00000         sub  32
FE27 6F         00000         ld   l,a
FE28 2600       00000         ld   h,0
FE2A 29         00000         add  hl,hl
FE2B 29         00000         add  hl,hl
FE2C 29         00000         add  hl,hl
FE2D ED5B365C   00000         ld   de,(CHARS)
FE31 19         00000         add  hl,de
FE32 24         00000         inc  h
FE33 11EBFD     00000         ld   de,CHAR
FE36 010800     00000         ld   bc,8
FE39 EDB0       00000         ldir
FE3B C9         00000         ret
FE3C            00000  ;
FE3C AF         00000  SETATT xor  a
FE3D 0608       00000         ld   b,8
FE3F 112000     00000         ld   de,32
FE42 211F58     00000         ld   hl,ATTR+31
FE45 DD21EBFD   00000         ld   ix,CHAR
FE49 DDCB007E   00000  NXTROW bit  7,(ix+0)
FE4D 2805       00000         jr   z,BLACK
FE4F 3AF5FD     00000         ld   a,(COLOUR)
FE52 1801       00000         jr   SETCOL
FE54 AF         00000  BLACK  xor  a
FE55 77         00000  SETCOL ld   (hl),a
FE56 19         00000         add  hl,de
FE57 77         00000         ld   (hl),a
FE58 19         00000         add  hl,de
FE59 77         00000         ld   (hl),a
FE5A 19         00000         add  hl,de
FE5B DD23       00000         inc  ix
FE5D 10EA       00000         djnz NXTROW
FE5F C9         00000         ret
FE60            00000  ;
FE60 0608       00000  ROTATE ld   b,8
FE62 21EBFD     00000         ld   hl,CHAR
FE65 CB06       00000  ROTNXT rlc  (hl)
FE67 23         00000         inc  hl
FE68 10FB       00000         djnz ROTNXT
FE6A C9         00000         ret
FE6B            00000  ;
FE6B            00000  ;Changed to only move the last
FE6B            00000  ;31 bytes of each row, to avoid
FE6B            00000  ;the left-most column getting
FE6B            00000  ;copied over to the right-hand
FE6B            00000  ;side before the next column
FE6B            00000  ;appears. Also stops the start
FE6B            00000  ;of the printer buffer being
FE6B            00000  ;copied into the attributes.
FE6B 210158     00000  MVATTR ld   hl,ATTR+1
FE6E 110058     00000         ld   de,ATTR
FE71 3E18       00000         ld   a,24
FE73 011F00     00000  MVANXT ld   bc,31
FE76 EDB0       00000         ldir
FE78 23         00000         inc  hl
FE79 13         00000         inc  de
FE7A 3D         00000         dec  a
FE7B 20F6       00000         jr   nz,MVANXT
FE7D C9         00000         ret
FE7E            00000  ;
FE7E 0608       00000  SHOW   ld   b,8
FE80 C5         00000  NXTBYT push bc
FE81 CD3CFE     00000         call SETATT
FE84 CD6BFE     00000         call MVATTR
FE87 76         00000         halt
FE88 CD3CFE     00000         call SETATT
FE8B CD6BFE     00000         call MVATTR
FE8E 76         00000         halt
FE8F CD60FE     00000         call ROTATE
FE92 010001     00000         ld   bc,256
FE95 0B         00000  DELAY  dec  bc
FE96 78         00000         ld   a,b
FE97 B1         00000         or   c
FE98 20FB       00000         jr   nz,DELAY
FE9A C1         00000         pop  bc
FE9B 10E3       00000         djnz NXTBYT
FE9D C9         00000         ret
FE9E            00000  ;
FE9E            00000  ;Changed to only LDIR 767 bytes
FE9E            00000  ;to avoid overwriting the 1st
FE9E            00000  ;byte of the printer buffer,
FE9E            00000  ;causing a crash on the 128K.
FE9E 210058     00000  RESET  ld   hl,ATTR
FEA1 110158     00000         ld   de,ATTR+1
FEA4 01FF02     00000         ld   bc,767
FEA7 75         00000         ld   (hl),l
FEA8 EDB0       00000         ldir
FEAA 210040     00000         ld   hl,SCREEN
FEAD CDB3FE     00000         call COPUDG
FEB0 CDB3FE     00000         call COPUDG
FEB3 11F6FD     00000  COPUDG ld   de,UDG
FEB6 0E08       00000         ld   c,8
FEB8 06FF       00000  COPROW ld   b,255
FEBA 1A         00000         ld   a,(de)
FEBB 77         00000  COPNXT ld   (hl),a
FEBC 23         00000         inc  hl
FEBD 10FC       00000         djnz COPNXT
FEBF 77         00000         ld   (hl),a
FEC0 23         00000         inc  hl
FEC1 13         00000         inc  de
FEC2 0D         00000         dec  c
FEC3 20F3       00000         jr   nz,COPROW
FEC5 C9         00000         ret
FEC6            00000  ;
5800            00000  ATTR   equ  22528
5C36            00000  CHARS  equ  23606
4000            00000  SCREEN equ  16384

00000 TOTAL ERRORS

ATTR         5800                       BLACK        FE54
CHAR         FDEB                       CHARS        5C36
COLOUR       FDF5                       COPNXT       FEBB
COPROW       FEB8                       COPUDG       FEB3
COPY         FE1E                       DELAY        FE95
LEN          FDF3                       MSG          FDE8
MVANXT       FE73                       MVATTR       FE6B
NXTBYT       FE80                       NXTCHR       FE05
NXTROW       FE49                       OFFSET       FDE9
RESET        FE9E                       ROTATE       FE60
ROTNXT       FE65                       SCREEN       4000
SETATT       FE3C                       SETCOL       FE55
SHOW         FE7E                       START1       FDFE
START2       FE01                       UDG          FDF6
